# Change Log
All notable changes to this project will be documented in this file.
This project adheres to [Semantic Versioning](https://semver.org/).
We are following the [Keep a Changelog](https://keepachangelog.com/) format.

## [Unreleased](https://github.com/FredrikNoren/ungit/compare/v1.5.26...master)

## [1.5.26](https://github.com/FredrikNoren/ungit/compare/v1.5.25...v1.5.26)

### Changed
- Bump Dependencies [#1584](https://github.com/FredrikNoren/ungit/pull/1584), [#1585](https://github.com/FredrikNoren/ungit/pull/1585), [#1587](https://github.com/FredrikNoren/ungit/pull/1587), [#1586](https://github.com/FredrikNoren/ungit/pull/1586)

## [1.5.25](https://github.com/FredrikNoren/ungit/compare/v1.5.24...v1.5.25)

### Changed
- Bump Dependencies [#1566](https://github.com/FredrikNoren/ungit/pull/1566), [#1571](https://github.com/FredrikNoren/ungit/pull/1571), [#1574](https://github.com/FredrikNoren/ungit/pull/1574), [#1578](https://github.com/FredrikNoren/ungit/pull/1578)

## [1.5.24](https://github.com/FredrikNoren/ungit/compare/v1.5.23...v1.5.24)

### Fixes
- Fallback for font if bundled font dont support glyphs [#1564](https://github.com/FredrikNoren/ungit/pull/1564)

### Changed
- Bump Dependencies [#1555](https://github.com/FredrikNoren/ungit/pull/1555), [#1559](https://github.com/FredrikNoren/ungit/pull/1559), [#1560](https://github.com/FredrikNoren/ungit/pull/1560), [#1561](https://github.com/FredrikNoren/ungit/pull/1561), [#1563](https://github.com/FredrikNoren/ungit/pull/1563)

## [1.5.23](https://github.com/FredrikNoren/ungit/compare/v1.5.22...v1.5.23)

### Fixes
- Ungit returns 0 when wrong arguments are used [#1548](https://github.com/FredrikNoren/ungit/issues/1548)
- Server process keeps running when parent gets killed [#1552](https://github.com/FredrikNoren/ungit/issues/1552)

### Changed
- Bump Dependencies [#1542](https://github.com/FredrikNoren/ungit/pull/1542), [#1545](https://github.com/FredrikNoren/ungit/pull/1545), [#1551](https://github.com/FredrikNoren/ungit/pull/1551)

## [1.5.22](https://github.com/FredrikNoren/ungit/compare/v1.5.21...v1.5.22)

### Fixes
- build: fix memory use by building serially [#1529](https://github.com/FredrikNoren/ungit/pull/1529)
- Small fixes and cleanups [#1530](https://github.com/FredrikNoren/ungit/pull/1530)

### Changed
- Update README.md [#1526](https://github.com/FredrikNoren/ungit/pull/1526)
- Update git version dependency to 2.34.x [#1536](https://github.com/FredrikNoren/ungit/pull/1536)
- Use fork to spawn a new node process [#1537](https://github.com/FredrikNoren/ungit/pull/1537)
- CI: git allow file protocol which is used in submodule tests [#1540](https://github.com/FredrikNoren/ungit/pull/1540)
- Bump Dependencies [#1525](https://github.com/FredrikNoren/ungit/pull/1525), [#1531](https://github.com/FredrikNoren/ungit/pull/1531), [#1533](https://github.com/FredrikNoren/ungit/pull/1533)

## [1.5.21](https://github.com/FredrikNoren/ungit/compare/v1.5.20...v1.5.21)

### Fixes
- fix patch checkbox html [#1517](https://github.com/FredrikNoren/ungit/pull/1517)

### Changed
- Bump Dependencies [#1512](https://github.com/FredrikNoren/ungit/pull/1512), [#1518](https://github.com/FredrikNoren/ungit/pull/1518)

### Removed
- Remove node 12 from build matrix [#1516](https://github.com/FredrikNoren/ungit/pull/1516)

## [1.5.20](https://github.com/FredrikNoren/ungit/compare/v1.5.19...v1.5.20)

### Fixes
- Fix potential remote code exec [#1510](https://github.com/FredrikNoren/ungit/pull/1510)
- Fix intermittent test failures [#1495](https://github.com/FredrikNoren/ungit/issues/1495)
- lint: small bugs + jsdoc [#1504](https://github.com/FredrikNoren/ungit/pull/1504)

### Changed
- Bump Dependencies [#1503](https://github.com/FredrikNoren/ungit/pull/1503)

## [1.5.19](https://github.com/FredrikNoren/ungit/compare/v1.5.18...v1.5.19)

### Added
- Add Tab Size Configuration [#1499](https://github.com/FredrikNoren/ungit/pull/1499)
- Types: add support for VSCode IntelliSense [#1466](https://github.com/FredrikNoren/ungit/pull/1466)

### Changed
- Directory view [#1491](https://github.com/FredrikNoren/ungit/pull/1491)
- Node watch [#1465](https://github.com/FredrikNoren/ungit/pull/1465)
- Bump cached-path-relative from 1.0.2 to 1.1.0 [#1501](https://github.com/FredrikNoren/ungit/pull/1501)
- Bump Dependencies [#1483](https://github.com/FredrikNoren/ungit/pull/1483), [#1487](https://github.com/FredrikNoren/ungit/pull/1487), [#1492](https://github.com/FredrikNoren/ungit/pull/1492), [#1494](https://github.com/FredrikNoren/ungit/pull/1494)

## [1.5.18](https://github.com/FredrikNoren/ungit/compare/v1.5.17...v1.5.18)

### Fixes
- simple git flow breaks ungit [#1460](https://github.com/FredrikNoren/ungit/issues/1460)

### Changed
- Bump Dependencies [#1479](https://github.com/FredrikNoren/ungit/pull/1479)

## [1.5.17](https://github.com/FredrikNoren/ungit/compare/v1.5.16...v1.5.17)

### Changed
- node 16 [#1476](https://github.com/FredrikNoren/ungit/pull/1476)
- Bump Dependencies [#1475](https://github.com/FredrikNoren/ungit/pull/1475)

## [1.5.16](https://github.com/FredrikNoren/ungit/compare/v1.5.15...v1.5.16)

### Added
- Add clipboard button on commit [#1462](https://github.com/FredrikNoren/ungit/pull/1462)
- Encode URI paths with slashes [#1378](https://github.com/FredrikNoren/ungit/pull/1378)

### Changed
- Bump Dependencies [#1456](https://github.com/FredrikNoren/ungit/pull/1456), [#1464](https://github.com/FredrikNoren/ungit/pull/1464)
- Bump elliptic from 6.5.3 to 6.5.4 [#1468](https://github.com/FredrikNoren/ungit/pull/1468)
- Bump y18n from 4.0.0 to 4.0.1 [#1471](https://github.com/FredrikNoren/ungit/pull/1471)
- git 2.3x changes break unittests [#1472](https://github.com/FredrikNoren/ungit/issues/1472)

## [1.5.15](https://github.com/FredrikNoren/ungit/compare/v1.5.14...v1.5.15)

### Changed
- Bump Dependencies [#1451](https://github.com/FredrikNoren/ungit/pull/1451)

## [1.5.14](https://github.com/FredrikNoren/ungit/compare/v1.5.13...v1.5.14)

### Changed
- Update socket.io to version 3.0.0 [#1443](https://github.com/FredrikNoren/ungit/pull/1443)
- Bump Dependencies [#1442](https://github.com/FredrikNoren/ungit/pull/1442), [#1444](https://github.com/FredrikNoren/ungit/pull/1444), [#1448](https://github.com/FredrikNoren/ungit/pull/1448), [#1449](https://github.com/FredrikNoren/ungit/pull/1449)

## [1.5.13](https://github.com/FredrikNoren/ungit/compare/v1.5.12...v1.5.13)

### Fixed
- Unhandled rejection ERR_FEATURE_NOT_AVAILABLE_ON_PLATFORM (recursive watch) [#1389](https://github.com/FredrikNoren/ungit/issues/1389)

### Changed
- Bump Dependencies [#1438](https://github.com/FredrikNoren/ungit/pull/1438)

## [1.5.12](https://github.com/FredrikNoren/ungit/compare/v1.5.11...v1.5.12)

### Fixed
- branches - can't re-enable disabled groups [#1434](https://github.com/FredrikNoren/ungit/issues/1434)
- Support git 2.29 sha256 [#1436](https://github.com/FredrikNoren/ungit/pull/1436)

### Changed
- Bump Dependencies [#1427](https://github.com/FredrikNoren/ungit/pull/1427)

## [1.5.11](https://github.com/FredrikNoren/ungit/compare/v1.5.10...v1.5.11)

### Added
- Doubleclick to checkout [#190](https://github.com/FredrikNoren/ungit/issues/190)

### Changed
- Use page.waitForTimeout API in tests [#1422](https://github.com/FredrikNoren/ungit/pull/1422)
- Bump Dependencies [#1417](https://github.com/FredrikNoren/ungit/pull/1417), [#1423](https://github.com/FredrikNoren/ungit/pull/1423)

## [1.5.10](https://github.com/FredrikNoren/ungit/compare/v1.5.9...v1.5.10)

### Fixed
- Add copyright to electron executable [#1411](https://github.com/FredrikNoren/ungit/issues/1411)

### Changed
- Generate and extract source maps [#1394](https://github.com/FredrikNoren/ungit/pull/1394)
- Import Bootstrap from npm and upgrade to latest 3.x [#1395](https://github.com/FredrikNoren/ungit/pull/1395)
- Bump Dependencies upgrading from electron 9.x to 10.x [#1392](https://github.com/FredrikNoren/ungit/pull/1392), [#1406](https://github.com/FredrikNoren/ungit/pull/1406)

## [1.5.9](https://github.com/FredrikNoren/ungit/compare/v1.5.8...v1.5.9)

### Fixed
- Fix git ignore settings [#1393](https://github.com/FredrikNoren/ungit/pull/1393)

## [1.5.8](https://github.com/FredrikNoren/ungit/compare/v1.5.7...v1.5.8)

### Fixed
- Clear git-promise timeout when git command was successful [#1357](https://github.com/FredrikNoren/ungit/pull/1357)
- When autoFetch=false don't make remote repo calls automatically [#1381](https://github.com/FredrikNoren/ungit/pull/1381)
- Prevent commit message <textarea> from resizing horizontally [#1390](https://github.com/FredrikNoren/ungit/pull/1390)
- Diff out is not properly escaping [#1387](https://github.com/FredrikNoren/ungit/issues/1387)

### Changed
- Migrate clicktests from nightmare to puppeteer [#1336](https://github.com/FredrikNoren/ungit/pull/1336)
- Prettify code with prettier [#1316](https://github.com/FredrikNoren/ungit/pull/1316)
- Switch from JSHint to ESLint [#1360](https://github.com/FredrikNoren/ungit/pull/1360)
- Bump Dependencies [#1355](https://github.com/FredrikNoren/ungit/pull/1355), [#1385](https://github.com/FredrikNoren/ungit/pull/1385)

### Removed
- Remove bluebird dependency [#1350](https://github.com/FredrikNoren/ungit/pull/1350)
- Remove grunt [#895](https://github.com/FredrikNoren/ungit/issues/895)

## [1.5.7](https://github.com/FredrikNoren/ungit/compare/v1.5.6...v1.5.7)

### Fixed
- Init tooltips from the app start [#1343](https://github.com/FredrikNoren/ungit/pull/1343)
- Fixing some accessibility issues [#1318](https://github.com/FredrikNoren/ungit/pull/1318)
- Flatten total-lines-changed object [#1330](https://github.com/FredrikNoren/ungit/pull/1330)
- Set electron window icon explicitly so it works during debug and on linux [#1347](https://github.com/FredrikNoren/ungit/pull/1347)

### Changed
- Only display ref search button when there are hidden refs [#1311](https://github.com/FredrikNoren/ungit/pull/1311), [#1325](https://github.com/FredrikNoren/ungit/pull/1325)
- Cleanup CSS styles [#1339](https://github.com/FredrikNoren/ungit/pull/1339), [#1328](https://github.com/FredrikNoren/ungit/pull/1328), [#1331](https://github.com/FredrikNoren/ungit/pull/1331), [#1332](https://github.com/FredrikNoren/ungit/pull/1332), [#1322](https://github.com/FredrikNoren/ungit/pull/1322)
- Style autocompletes like dropdowns [#1327](https://github.com/FredrikNoren/ungit/pull/1327)
- Optimizes ref-search autocomplete initialization [#1326](https://github.com/FredrikNoren/ungit/pull/1326)
- Reduce jQuery UI imports and use Bootstrap tooltips [#1340](https://github.com/FredrikNoren/ungit/pull/1340)
- Image cleanup [#1345](https://github.com/FredrikNoren/ungit/pull/1345)
- Bump Dependencies [#1309](https://github.com/FredrikNoren/ungit/pull/1309)

### Removed
- Remove unused color dependency [#1341](https://github.com/FredrikNoren/ungit/pull/1341)
- Remove image embed [#1346](https://github.com/FredrikNoren/ungit/pull/1346)
- Remove unused tracker.js [#1344](https://github.com/FredrikNoren/ungit/pull/1344)

## [1.5.6](https://github.com/FredrikNoren/ungit/compare/v1.5.5...v1.5.6)

### Fixed
- Continue rebase fails with git 2.26 [#1301](https://github.com/FredrikNoren/ungit/issues/1301)
- Dependency updates [#1304](https://github.com/FredrikNoren/ungit/pull/1304), [#1300](https://github.com/FredrikNoren/ungit/pull/1300), [#1297](https://github.com/FredrikNoren/ungit/pull/1297), [#1295](https://github.com/FredrikNoren/ungit/pull/1295)
- ignore nmclicktests and ci files in npm package [#1306](https://github.com/FredrikNoren/ungit/pull/1306)

### Added
- GitHub Action CI [#1298](https://github.com/FredrikNoren/ungit/pull/1298)
- GitHub Action dependency bump [#1296](https://github.com/FredrikNoren/ungit/pull/1296)

## [1.5.5](https://github.com/FredrikNoren/ungit/compare/v1.5.4...v1.5.5)

### Fixed
- Bump dependencies [#1283](https://github.com/FredrikNoren/ungit/pull/1283)
- Running npm scripts on macOS [#1287](https://github.com/FredrikNoren/ungit/pull/1287)
- Reduce CPU and Memory consumption in textdiff. Addresses part of [#1091](https://github.com/FredrikNoren/ungit/issues/1091)
- Better focus handling when creating branches and tags [#1288](https://github.com/FredrikNoren/ungit/pull/1288)
- Don't show error page when reloading the page [#1289](https://github.com/FredrikNoren/ungit/issues/1289)
- Periodically update author date of commits again [#1286](https://github.com/FredrikNoren/ungit/pull/1286)

## [1.5.4](https://github.com/FredrikNoren/ungit/compare/v1.5.3...v1.5.4)

### Fixed
- forcedLaunchPath of null fails to work [#1281](https://github.com/FredrikNoren/ungit/issues/1281)

### Changed
- Update diff2html to version 3 [#1273](https://github.com/FredrikNoren/ungit/pull/1273)

### Removed
- Remove dependency on npm [#1269](https://github.com/FredrikNoren/ungit/pull/1269)

## [1.5.3](https://github.com/FredrikNoren/ungit/compare/v1.5.2...v1.5.3)

### Fixed
- Git log for merge / empty commits does not work correctly [#1270](https://github.com/FredrikNoren/ungit/issues/1270)

## [1.5.2](https://github.com/FredrikNoren/ungit/compare/v1.5.1...v1.5.2)

### Fixed
- Diff does not work for first commit [#1124](https://github.com/FredrikNoren/ungit/issues/1124)
- `--no-launchBrowser` is ignored when ungit already running [#1259](https://github.com/FredrikNoren/ungit/issues/1259)
- Bare repositories don't work with git 2.25 [#1265](https://github.com/FredrikNoren/ungit/issues/1265)
- ungit crashes if current directory is deleted [#1266](https://github.com/FredrikNoren/ungit/issues/1266)
- Make clicktests more reliable [#1263](https://github.com/FredrikNoren/ungit/pull/1263)
- Rename + changes only show rename [#1175](https://github.com/FredrikNoren/ungit/issues/1175)

### Removed
- Remove Node 8 from build matrix [#1256](https://github.com/FredrikNoren/ungit/pull/1256)

## [1.5.1](https://github.com/FredrikNoren/ungit/compare/v1.5.0...v1.5.1)

### Fixed
- Fix copy and paste in electron on macOS [#1251](https://github.com/FredrikNoren/ungit/issues/1251)

## [1.5.0](https://github.com/FredrikNoren/ungit/compare/v1.4.48...v1.5.0)

### Added
- Include file diff in merge commits [#1242](https://github.com/FredrikNoren/ungit/pull/1242)
- Hide diff buttons on hover [#1225](https://github.com/FredrikNoren/ungit/pull/1225)
- Publish electron build [#1241](https://github.com/FredrikNoren/ungit/pull/1241)

### Fixed
- Updated Octicons [#1224](https://github.com/FredrikNoren/ungit/pull/1224), [#1245](https://github.com/FredrikNoren/ungit/pull/1245), [#1246](https://github.com/FredrikNoren/ungit/pull/1246)
- Fix stash tooltips [#1227](https://github.com/FredrikNoren/ungit/pull/1227)
- Improve git-init experience [#1228](https://github.com/FredrikNoren/ungit/pull/1228)
- Fix inconsistent diff options [#1229](https://github.com/FredrikNoren/ungit/issues/1229)
- Fix clearing .gitignore [#1236](https://github.com/FredrikNoren/ungit/pull/1236)
- Fix electron package [#1240](https://github.com/FredrikNoren/ungit/pull/1240), [#1248](https://github.com/FredrikNoren/ungit/pull/1248)
- Minor fixes to remove warnings [#1235](https://github.com/FredrikNoren/ungit/pull/1235), [#1237](https://github.com/FredrikNoren/ungit/pull/1237), [#1238](https://github.com/FredrikNoren/ungit/pull/1238), [#1239](https://github.com/FredrikNoren/ungit/pull/1239)

## [1.4.48](https://github.com/FredrikNoren/ungit/compare/v1.4.47...v1.4.48)

### Fixed
- fix the width value of the header logo [#1221](https://github.com/FredrikNoren/ungit/pull/1221)

## [1.4.47](https://github.com/FredrikNoren/ungit/compare/v1.4.46...v1.4.47)

### Fixed
- make diff2html line numbers and +/- prefixes unselectable [#1214](https://github.com/FredrikNoren/ungit/issues/1214), [#1215](https://github.com/FredrikNoren/ungit/pull/1215)

## [1.4.46](https://github.com/FredrikNoren/ungit/compare/v1.4.45...v1.4.46)

### Fixed
- force git out put to be in English within ungit [#1208](https://github.com/FredrikNoren/ungit/pull/1208)

## [1.4.45](https://github.com/FredrikNoren/ungit/compare/v1.4.44...v1.4.45)

### Fixed
- Improve styling of .gitignore edit dialog [#1205](https://github.com/FredrikNoren/ungit/pull/1205)

## [1.4.44](https://github.com/FredrikNoren/ungit/compare/v1.4.43...v1.4.44)

### Added
- add config to disable numstat in staged diff to better performance [#1193](https://github.com/FredrikNoren/ungit/issues/1193)

## [1.4.43](https://github.com/FredrikNoren/ungit/compare/v1.4.42...v1.4.43)

### Fixed
- fix gitignore manual edit not being saved [#644](https://github.com/FredrikNoren/ungit/issues/644)
- fix issue with detached git processes on some OS and timeout not being enforced.
- simplify `maxSearchIteration` enforcement for git.log()
- change `alwaysLoadActiveBranch` boolean config to `maxActiveBranchSearchIteration` numeric config
- bumped node engine requirement to [10.14 Dubnium](https://github.com/nodejs/node/blob/master/doc/changelogs/CHANGELOG_V10.md#10.14.2)

## [1.4.42](https://github.com/FredrikNoren/ungit/compare/v1.4.41...v1.4.42)

### Fixed
- Add "Ignore white space" config [#1185](https://github.com/FredrikNoren/ungit/pull/1185)

## [1.4.41](https://github.com/FredrikNoren/ungit/compare/v1.4.40...v1.4.41)

### Removed
- Remove Google Analytics [#1182](https://github.com/FredrikNoren/ungit/pull/1182)

## [1.4.40](https://github.com/FredrikNoren/ungit/compare/v1.4.39...v1.4.40)

### Removed
- Remove Keen.io [#1180](https://github.com/FredrikNoren/ungit/pull/1180)

## [1.4.39](https://github.com/FredrikNoren/ungit/compare/v1.4.38...v1.4.39)

### Fixed
- Add git bin path config. [#1151](https://github.com/FredrikNoren/ungit/issues/1151)

## [1.4.38](https://github.com/FredrikNoren/ungit/compare/v1.4.37...v1.4.38)

### Fixed
- Fix: Highlight current branch in submodules

## [1.4.37](https://github.com/FredrikNoren/ungit/compare/v1.4.36...v1.4.37)

### Fixed
- Sort modules by names

## [1.4.36](https://github.com/FredrikNoren/ungit/compare/v1.4.35...v1.4.36)

### Fixed
- fix changing remotes in remotes dropdown [#1158](https://github.com/FredrikNoren/ungit/pull/1158)

## [1.4.35](https://github.com/FredrikNoren/ungit/compare/v1.4.34...v1.4.35)

### Fixed
- allow disabling of nprogress bar [#1143](https://github.com/FredrikNoren/ungit/issues/1143)
- set `ungitVersionCheckOverride` as boolean in config [#1102](https://github.com/FredrikNoren/ungit/issues/1102)

## [1.4.34](https://github.com/FredrikNoren/ungit/compare/v1.4.33...v1.4.34)

### Fixed
- fix issues when remote tags doesn't show [#1139](https://github.com/FredrikNoren/ungit/issues/1139)

## [1.4.33](https://github.com/FredrikNoren/ungit/compare/v1.4.32...v1.4.33)

### Fixed
- Bump getmac version [#1130](https://github.com/FredrikNoren/ungit/issues/1130)
- Add config to disable animation [#1136](https://github.com/FredrikNoren/ungit/issues/1136)
- dependency bumps
- Remove node6. Add node8 and node9 explicitly.

## [1.4.32](https://github.com/FredrikNoren/ungit/compare/v1.4.31...v1.4.32)

### Fixed
- Handle crashes with better logs
- Wrap localStorage to support environments without access to it

## [1.4.31](https://github.com/FredrikNoren/ungit/compare/v1.4.30...v1.4.31)

### Fixed
- Add error logging for npm publish

## [1.4.30](https://github.com/FredrikNoren/ungit/compare/v1.4.29...v1.4.30)

### Fixed
- Add `ungitBindIp` config to allow default binding in some cases [#1112](https://github.com/FredrikNoren/ungit/issues/1112)

## [1.4.29](https://github.com/FredrikNoren/ungit/compare/v1.4.28...v1.4.29)

### Fixed
- Add `--no-optional-locks` if git version is appropriate [#1105](https://github.com/FredrikNoren/ungit/issues/1105)
- Ensure ungit server to bind to `127.0.0.1` [#988](https://github.com/FredrikNoren/ungit/issues/988)
- Add node highlight on mouse hover on relationship path [#1093](https://github.com/FredrikNoren/ungit/issues/1093)

## [1.4.28](https://github.com/FredrikNoren/ungit/compare/v1.4.27...v1.4.28)

### Fixed
- adding raven locally for offline access. [#1107](https://github.com/FredrikNoren/ungit/pull/1107)

## [1.4.27](https://github.com/FredrikNoren/ungit/compare/v1.4.26...v1.4.27)

### Fixed
- logic change for the merge conflict resolution

## [1.4.26](https://github.com/FredrikNoren/ungit/compare/v1.4.25...v1.4.26)

### Added
- add a way to preconfigure repo lists [#1106](https://github.com/FredrikNoren/ungit/issues/1106)

## [1.4.25](https://github.com/FredrikNoren/ungit/compare/v1.4.24...v1.4.25)

### Added
- add git pgp signing docs and code [#740](https://github.com/FredrikNoren/ungit/issues/740)

## [1.4.24](https://github.com/FredrikNoren/ungit/compare/v1.4.23...v1.4.24)

### Fixed
- change `/api/log` -> `/api/gitlog` as some ad blockers really hates This
- Fix excessive error messaging when disconnected from internet
- Fix Raven initialization error when disconnected from internet

## [1.4.23](https://github.com/FredrikNoren/ungit/compare/v1.4.22...v1.4.23)

### Fixed
- add feature to do `--recurse-submodules` for git clone [#1080](https://www.gnupg.org/documentation/manpage.html
- increase debounce 250->500 wait and 1000->2000 sec so UI can pick up server changes more accurately

## [1.4.22](https://github.com/FredrikNoren/ungit/compare/v1.4.21...v1.4.22)

### Fixed
- Fix missing jQuery and jQuery UI references [#1086](https://github.com/FredrikNoren/ungit/issues/1086)

## [1.4.21](https://github.com/FredrikNoren/ungit/compare/v1.4.20...v1.4.21)

### Fixed
- Treat remote fetch fail as an warning rather than error [#1081](https://github.com/FredrikNoren/ungit/issues/1081)

## [1.4.20](https://github.com/FredrikNoren/ungit/compare/v1.4.19...v1.4.20)

### Fixed
- deleted checked in 3rd party codes and manage by npm.
- remove dependencies on async lib

## [1.4.19](https://github.com/FredrikNoren/ungit/compare/v1.4.18...v1.4.19)

### Fixed
- fix credential helper not fetching all the authentication data [#1078](https://github.com/FredrikNoren/ungit/pull/1078)

## [1.4.18](https://github.com/FredrikNoren/ungit/compare/v1.4.17...v1.4.18)

### Fixed
- fix inaccurate git state issue when new branch name conflict and `autoCheckoutOnBranchCreate` is enabled.
- Add content refresh on .gitignore file change
- fix reference filtering

## [1.4.17](https://github.com/FredrikNoren/ungit/compare/v1.4.16...v1.4.17)

### Fixed
- fix textarea with in dialog when editing .gitignore [#1068](https://github.com/FredrikNoren/ungit/pull/1068)

## [1.4.16](https://github.com/FredrikNoren/ungit/compare/v1.4.15...v1.4.16)

### Fixed
- Move version number to below logo. [#1069](https://github.com/FredrikNoren/ungit/pull/1069)

## [1.4.15](https://github.com/FredrikNoren/ungit/compare/v1.4.14...v1.4.15)

### Fixed
- fix not setting `pathToNavigateTo` properly when `launchBrowser` is false and `launchCommand` is set [#1065](https://github.com/FredrikNoren/ungit/issues/1065)

## [1.4.14](https://github.com/FredrikNoren/ungit/compare/v1.4.13...v1.4.14)

### Fixed
- fix credential helper when ungit is used with rootpath [#1060](https://github.com/FredrikNoren/ungit/issues/1060)

## [1.4.13](https://github.com/FredrikNoren/ungit/compare/v1.4.12...v1.4.13)

### Fixed
- Change raven web client source to CDN rather than local copy [#972](https://github.com/FredrikNoren/ungit/issues/972)
- dependency bump

## [1.4.12](https://github.com/FredrikNoren/ungit/compare/v1.4.11...v1.4.12)

### Fixed
- Adding internet disconnected state handling [#1014](https://github.com/FredrikNoren/ungit/issues/1014)
- Allow editing .gitignore via ungit [#976](https://github.com/FredrikNoren/ungit/issues/1014)

## [1.4.11](https://github.com/FredrikNoren/ungit/compare/v1.4.10...v1.4.11)

### Added
- add cancel button for empty commits and amends [#1029](https://github.com/FredrikNoren/ungit/issues/1029)

### Fixed
- differentiate remote vs local tag. [#1016](https://github.com/FredrikNoren/ungit/issues/1016)
- fix push not throwing giterror
- fix remote tag push not creating remote tag
- change ref refresh logic
- show error on incorrect credentials [#1042](https://github.com/FredrikNoren/ungit/pull/1042)
- allow credential handling for remotes [#1039](https://github.com/FredrikNoren/ungit/issues/1039)
- cleanup clicktest output [#1035](https://github.com/FredrikNoren/ungit/pull/1035)

## [1.4.10](https://github.com/FredrikNoren/ungit/compare/v1.4.9...v1.4.10)

### Added
- add commit & push option [#1038](https://github.com/FredrikNoren/ungit/issues/1038)

### Fixed
- hide / disable push option if there is no remote [#1050](https://github.com/FredrikNoren/ungit/issues/1050)

## [1.4.9](https://github.com/FredrikNoren/ungit/compare/v1.4.8...v1.4.9)

### Fixed
- handle failed promises [#1017](https://github.com/FredrikNoren/ungit/issues/1017)
- empty commit [#1028](https://github.com/FredrikNoren/ungit/issues/1028)
- fix commit detail layout while hovering over commit node [#1025](https://github.com/FredrikNoren/ungit/issues/1025)

## [1.4.8](https://github.com/FredrikNoren/ungit/compare/v1.4.7...v1.4.8)

### Fixed
- fix remote branches display name and delete action [#1032](https://github.com/FredrikNoren/ungit/issues/1032), [#1031](https://github.com/FredrikNoren/ungit/issues/1031)

## [1.4.7](https://github.com/FredrikNoren/ungit/compare/v1.4.6...v1.4.7)

### Added
- add remote branches to the branch list. [#966](https://github.com/FredrikNoren/ungit/issues/966)

## [1.4.6](https://github.com/FredrikNoren/ungit/compare/v1.4.5...v1.4.6)

### Fixed
- dependency bump to fix dependency's security problem.
- Add emphasis if remote branch delete for confirmation dialog. [#947](https://github.com/FredrikNoren/ungit/issues/947)

## [1.4.5](https://github.com/FredrikNoren/ungit/compare/v1.4.4...v1.4.5)

### Fixed
- fix a bug where no diff wasn't properly showing [#969](https://github.com/FredrikNoren/ungit/issues/969)

## [1.4.4](https://github.com/FredrikNoren/ungit/compare/v1.4.3...v1.4.4)

### Fixed
- fix a bug where fetch is disabled after page load
- make `forceLaunchPath` to supersede `launchBrowser` [#1006](https://github.com/FredrikNoren/ungit/issues/1006)

## [1.4.3](https://github.com/FredrikNoren/ungit/compare/v1.4.2...v1.4.3)

### Fixed
- changing to path navigation to `nprogress` bar. [#1001](https://github.com/FredrikNoren/ungit/issues/1001)

## [1.4.2](https://github.com/FredrikNoren/ungit/compare/v1.4.1...v1.4.2)

### Fixed
- fix navigation redirection on git clone and adding xkcd image
- dependency bump

## [1.4.1](https://github.com/FredrikNoren/ungit/compare/v1.4.0...v1.4.1)

### Fixed
- fix the issue where browser opens before ungit start. [#994](https://github.com/FredrikNoren/ungit/issues/994)
- including xkcd art back [#999](https://github.com/FredrikNoren/ungit/issues/999)

## [1.4.0](https://github.com/FredrikNoren/ungit/compare/v1.3.3...v1.4.0)

### Fixed
- Revert to MIT [#947](https://github.com/FredrikNoren/ungit/issues/974)

## [1.3.3](https://github.com/FredrikNoren/ungit/compare/v1.3.2...v1.3.3)

### Fixed
- fix `tagsToDisplay` clearing issue. [#973](https://github.com/FredrikNoren/ungit/issues/973)

## [1.3.2](https://github.com/FredrikNoren/ungit/compare/v1.3.1...v1.3.2)

### Added
- Adding in ref search box and limit num of ref display [#973](https://github.com/FredrikNoren/ungit/issues/973)

## [1.3.1](https://github.com/FredrikNoren/ungit/compare/v1.3.0...v1.3.1)

### Added
- Add link to plans & license in header [#947](https://github.com/FredrikNoren/ungit/issues/974)

## [1.3.0](https://github.com/FredrikNoren/ungit/compare/v1.2.3...v1.3.0)

### Fixed
- Switch to Faircode paywall instead of license popup [#947](https://github.com/FredrikNoren/ungit/issues/974)

## [1.2.3](https://github.com/FredrikNoren/ungit/compare/v1.2.2...v1.2.3)

### Fixed
- Bump license text to v0.2.1 (fixes typo). [Faircode License changelog](https://github.com/faircodeio/faircode-license/blob/master/CHANGELOG.md)

## [1.2.2](https://github.com/FredrikNoren/ungit/compare/v1.2.1...v1.2.2)

### Fixed
-  Bump license text to v0.2 to fix two small inconsistencies: Clarify currency (USD) and remove "no additional rights" clause as it's problematic and superfluous. License changelog at https://github.com/faircodeio/faircode-license/blob/master/CHANGELOG.md [#947](https://github.com/FredrikNoren/ungit/issues/974)

## [1.2.1](https://github.com/FredrikNoren/ungit/compare/v1.2.0...v1.2.1)

### Fixed
- fix for not launching browser when executed at the git repo [#986](https://github.com/FredrikNoren/ungit/issues/986)

## [1.2.0](https://github.com/FredrikNoren/ungit/compare/v1.1.33...v1.2.0)

### Fixed
- Show license notification on first start (license changed in 1.1.32) [#947](https://github.com/FredrikNoren/ungit/issues/974)
- fix potential memory leak with `express-session`[#977](https://github.com/FredrikNoren/ungit/issues/977)
- Fix document title on windows [#983](https://github.com/FredrikNoren/ungit/pull/983)
- parse local storage as json instead of regex [#981](https://github.com/FredrikNoren/ungit/pull/981)
- resolve path keywords such as `~` at server side [#980](https://github.com/FredrikNoren/ungit/issues/975)

## [1.1.33](https://github.com/FredrikNoren/ungit/compare/v1.1.32...v1.1.33)

### Fixed
- Make Logo and favicon HiDpi [#589](https://github.com/FredrikNoren/ungit/issues/589)
- Remove forever-monitor [#961](https://github.com/FredrikNoren/ungit/issues/961)

## [1.1.32](https://github.com/FredrikNoren/ungit/compare/v1.1.31...v1.1.32)

### Fixed
- Update license [#974](https://github.com/FredrikNoren/ungit/issues/974)

## [1.1.31](https://github.com/FredrikNoren/ungit/compare/v1.1.30...v1.1.31)

### Fixed
- Bump dependencies

## [1.1.30](https://github.com/FredrikNoren/ungit/compare/v1.1.29...v1.1.30)

### Fixed
- move unit tests to es6
- Add squash feature [#129](https://github.com/FredrikNoren/ungit/issues/129)

## [1.1.29](https://github.com/FredrikNoren/ungit/compare/v1.1.28...v1.1.29)

### Fixed
- move `Gruntfile.js` to es6

## [1.1.28](https://github.com/FredrikNoren/ungit/compare/v1.1.27...v1.1.28)

### Fixed
- Refactoring to remove static data-ta tags from tests
- `grunt nmclicktest` -> `grunt clicktest`
- Stabilize ungit open test of clicktest via using a tag that is guaranteed to be generated
- Add click test bailout on tes failure
- Add parallel click test `grunt clickParallel`
- Remove deps to fix config init bug for the `credentials-helper`. [#838](https://github.com/FredrikNoren/ungit/issues/838)

## [1.1.27](https://github.com/FredrikNoren/ungit/compare/v1.1.26...v1.1.27)

### Fixed
- Add alert when moving back in time. [#914](https://github.com/FredrikNoren/ungit/issues/914)

## [1.1.26](https://github.com/FredrikNoren/ungit/compare/v1.1.25...v1.1.26)

### Fixed
- fix invalid path input for autocomplete causing front end crash [#942](https://github.com/FredrikNoren/ungit/issues/942)
- bump and checking in package-lock.json

## [1.1.25](https://github.com/FredrikNoren/ungit/compare/v1.1.24...v1.1.25)

### Fixed
- Change stash pop operation to stash apply [#919](https://github.com/FredrikNoren/ungit/issues/919)

## [1.1.24](https://github.com/FredrikNoren/ungit/compare/v1.1.23...v1.1.24)

### Fixed
- fix some commands not properly reporting git error [#933](https://github.com/FredrikNoren/ungit/issues/933)

## [1.1.23](https://github.com/FredrikNoren/ungit/compare/v1.1.22...v1.1.23)

### Fixed
- finalize nightmare click test

## [1.1.22](https://github.com/FredrikNoren/ungit/compare/v1.1.21...v1.1.22)

### Fixed
- Add a config setting to allow setting the default diff type. [#929](https://github.com/FredrikNoren/ungit/issues/929)

## [1.1.21](https://github.com/FredrikNoren/ungit/compare/v1.1.20...v1.1.21)

### Fixed
- Initial refactoring of click test using nightmare and mocha
- **Dropping support for node 4.x and 5.x!, 6.x and later is now supported.**

## [1.1.20](https://github.com/FredrikNoren/ungit/compare/v1.1.19...v1.1.20)

### Fixed
- Hide credentials in remote urls at home repo list

## [1.1.19](https://github.com/FredrikNoren/ungit/compare/v1.1.18...v1.1.19)

### Fixed
- Ask before deleting a stash

## [1.1.18](https://github.com/FredrikNoren/ungit/compare/v1.1.17...v1.1.18)

### Fixed
- Fix checking out remote refs (again)

## [1.1.17](https://github.com/FredrikNoren/ungit/compare/v1.1.16...v1.1.17)

### Fixed
- Fix checking out remote refs

## [1.1.16](https://github.com/FredrikNoren/ungit/compare/v1.1.15...v1.1.16)

### Fixed
- clicktests logging correction and using wait for within tests.
- Refactor filewatch and using normalized test path
- throttle parallel test's parellelization limit
- dependency bump
- Fix context issue for `gitSetUserConfig` [#912](https://github.com/FredrikNoren/ungit/issues/912)

## [1.1.15](https://github.com/FredrikNoren/ungit/compare/v1.1.14...v1.1.15)

### Fixed
- Updating crash page with instructions and adblock detection

## [1.1.14](https://github.com/FredrikNoren/ungit/compare/v1.1.13...v1.1.14)

### Fixed
- Disable strict mode for startup params and config [#890](https://github.com/FredrikNoren/ungit/issues/890)

## [1.1.13](https://github.com/FredrikNoren/ungit/compare/v1.1.12...v1.1.13)

### Fixed
- Fix startup args bug: [#896](https://github.com/FredrikNoren/ungit/issues/896)

## [1.1.12](https://github.com/FredrikNoren/ungit/compare/v1.1.11...v1.1.12)

### Fixed
- Retain commit messages when commit fails [#882](https://github.com/FredrikNoren/ungit/pull/882)
- Fix rare edge case where remote node is gone during reset op.
- rescursively resolve all promises before caching them. [#878](https://github.com/FredrikNoren/ungit/pull/878)

## [1.1.11](https://github.com/FredrikNoren/ungit/compare/v1.1.10...v1.1.11)

### Fixed
- Fix cli arguments [#871](https://github.com/FredrikNoren/ungit/pull/871)
- Stop if ~/.ungitrc contains syntax error
- Removed official support ini format of ~/.ungitrc, because internal API supports only JSON

## [1.1.10](https://github.com/FredrikNoren/ungit/compare/v1.1.9...v1.1.10)

### Fixed
- Fix broken diff out in some cases when diff contains table. [#881](https://github.com/FredrikNoren/ungit/pull/881)

## [1.1.9](https://github.com/FredrikNoren/ungit/compare/v1.1.8...v1.1.9)

### Fixed
- Fix around ubuntu's inability to cache promises. [#877](https://github.com/FredrikNoren/ungit/pull/878)

## [1.1.8](https://github.com/FredrikNoren/ungit/compare/v1.1.7...v1.1.8)

### Fixed
- Realtime text diff via invalidate diff on directory change [#867](https://github.com/FredrikNoren/ungit/pull/867)
- Promisify `./source/utils/cache.js` [#870](https://github.com/FredrikNoren/ungit/pull/870)
- Fix load more text diff button. [#876](https://github.com/FredrikNoren/ungit/pull/876)

## [1.1.7](https://github.com/FredrikNoren/ungit/compare/v1.1.6...v1.1.7)

### Fixed
- Fix diff flickering issue and optimization [#865](https://github.com/FredrikNoren/ungit/pull/865)
- Fix credential dialog issue [#864](https://github.com/FredrikNoren/ungit/pull/864)
- Fix HEAD branch order when redraw [#858](https://github.com/FredrikNoren/ungit/issues/858)

## [1.1.6](https://github.com/FredrikNoren/ungit/compare/v1.1.5...v1.1.6)

### Fixed
- Fix path auto complete [#861](https://github.com/FredrikNoren/ungit/issues/861)

## [1.1.5](https://github.com/FredrikNoren/ungit/compare/v1.1.4...v1.1.5)

### Fixed
- Update "Toggle all" button after commit or changing selected files [#859](https://github.com/FredrikNoren/ungit/issues/859)

## [1.1.4](https://github.com/FredrikNoren/ungit/compare/v1.1.3...v1.1.4)

### Fixed
- [patch] Promise refactoring

## [1.1.3](https://github.com/FredrikNoren/ungit/compare/v1.1.2...v1.1.3)

### Fixed
- [patch] Fix submodule navigation on windows [#577](https://github.com/FredrikNoren/ungit/issues/577)

## [1.1.2](https://github.com/FredrikNoren/ungit/compare/v1.1.1...v1.1.2)

### Fixed
- Fix a bug that prevented the new version dialog from being dismissed

## [1.1.1](https://github.com/FredrikNoren/ungit/compare/v1.1.0...v1.1.1)

### Fixed
- [patch] Fixed small spelling error for ignore whitespace feature [#853](https://github.com/FredrikNoren/ungit/pull/853)

## [1.1.0](https://github.com/FredrikNoren/ungit/compare/v1.0.1...v1.1.0)

### Added
- Added option to ignore ungit version checks [#851](https://github.com/FredrikNoren/ungit/issues/851)

## [1.0.1](https://github.com/FredrikNoren/ungit/compare/v1.0.0...v1.0.1)

### Fixed
- [patch] Fixed gravatar avatar fetch if email have different cases applied. [#847](https://github.com/FredrikNoren/ungit/issues/847)

## [1.0.0](https://github.com/FredrikNoren/ungit/compare/v0.10.3...v1.0.0)

### Added
- Added search by git folder name in the search bar. [#793](https://github.com/FredrikNoren/ungit/issues/793)
- New configuration option `logLevel` allows you to assign the level of logging you want to see in the servers output console.
- New configuration option `mergeTool` allows you to assign a custom external merge tool for conflict resolution [#783](https://github.com/FredrikNoren/ungit/issues/783) [Doc](https://github.com/FredrikNoren/ungit/blob/master/MERGETOOL.md)
- Whitespace ignore option for text diffs [#777](https://github.com/FredrikNoren/ungit/issues/777)
- Fix for favorites linking in case rootPath is used @sebastianmay [#609](https://github.com/FredrikNoren/ungit/issues/609) and image diffing
- Limit commit title to 72 characters, the rest is truncated and shown when inspecting the commit
- Updated file watch logic to closely follow git commands in another process [#283](https://github.com/FredrikNoren/ungit/issues/283)
- Introduced Continuous delivery. [#823](https://github.com/FredrikNoren/ungit/issues/823)

### Fixed
- File diff firing increasing number of events longer it survives.
- Fix missing ungit logo. [#812](https://github.com/FredrikNoren/ungit/issues/812)
- Fix when stash output is empty [#818](https://github.com/FredrikNoren/ungit/issues/818)
- Fix minor display error for wide git repo [#830](https://github.com/FredrikNoren/ungit/pull/830)
- Persist commit messages during merge operation [#779](https://github.com/FredrikNoren/ungit/issues/779)
- Refresh `staging.files` object for cleaner refresh such as refresh pached line list, diff and etc.
- Fixed an issue where patching on some key word file names such as "test".
- Fix missing commit message body if commit was committed with Visual Studio or Visual Studio Code [#826](https://github.com/FredrikNoren/ungit/pull/826)
- Fix initial page load when loaded node does not fits in screen. [#832](https://github.com/FredrikNoren/ungit/issues/832)

## [0.10.3](https://github.com/FredrikNoren/ungit/compare/v0.10.2...v0.10.3)

### Added
- Show diffs for stashed changes [#444](https://github.com/FredrikNoren/ungit/issues/444)
- Active node focused git log result [#420](https://github.com/FredrikNoren/ungit/issues/420)

### Fixed
- Missing npm as a normal dependency [#766](https://github.com/FredrikNoren/ungit/issues/766)

## [0.10.2](https://github.com/FredrikNoren/ungit/compare/v0.10.1...v0.10.2)

### Fixed
- Handle SIGTERM and SIGINT [#763](https://github.com/FredrikNoren/ungit/issues/763)

### Added
- Added bare repo support [#177](https://github.com/FredrikNoren/ungit/issues/177) [#728](https://github.com/FredrikNoren/ungit/issues/728)
- Added support for cherry-pick conflict[#701](https://github.com/FredrikNoren/ungit/issues/701)
- Added wordwrap support for diffs [#721](https://github.com/FredrikNoren/ungit/issues/721)
- Support for Node6 [#745](https://github.com/FredrikNoren/ungit/pull/745/files)
- Added "autoCheckoutOnBranchCreate" option [#752](https://github.com/FredrikNoren/ungit/pull/752/files)

### Fixed
- Fix maxConcurrentGitOperations not limiting git processes [#707](https://github.com/FredrikNoren/ungit/issues/707)
- Fix ".lock" file conflicts in parallelized git operations [#515](https://github.com/FredrikNoren/ungit/issues/515)
- Allow Ungit to function under sub dir of a git dir [#734](https://github.com/FredrikNoren/ungit/issues/734)
- Removed deprecated npmconf package [#746](https://github.com/FredrikNoren/ungit/issues/746)
- More helpful warning messages [#749](https://github.com/FredrikNoren/ungit/pull/749/files)
- Deleting already deleted remote tag [#748](https://github.com/FredrikNoren/ungit/pull/748)
- Fix to handle revert merge commit [#757](https://github.com/FredrikNoren/ungit/pull/757)

### Changed
- Cleaner rebase conflict message display [#708](https://github.com/FredrikNoren/ungit/pull/708)
- ES6 [#672](https://github.com/FredrikNoren/ungit/pull/672)
- Dropped support for Node 0.10 and 0.12 [#745](https://github.com/FredrikNoren/ungit/pull/745/files)

## [0.10.1](https://github.com/FredrikNoren/ungit/compare/v0.10.0...v0.10.1)

### Added
- Introduced change log! [#687](https://github.com/FredrikNoren/ungit/issues/687)
- Improved server and client error logging [#695](https://github.com/FredrikNoren/ungit/pull/695)

### Fixed
- Fix crashes due to submodule parsing [#690](https://github.com/FredrikNoren/ungit/issues/690) [#689](https://github.com/FredrikNoren/ungit/issues/689)
- Fix duplicate remote tag issues [#685](https://github.com/FredrikNoren/ungit/issues/685)
- Fix scrolling issue in safari [#686](https://github.com/FredrikNoren/ungit/issues/686)
- Fix git hooks failing on non-ascii files [#676](https://github.com/FredrikNoren/ungit/issues/676)

### Removed
- Reverted on hover button effects [#688](https://github.com/FredrikNoren/ungit/issues/688)

### Changed
- Upgrade keen.io client code [#679](https://github.com/FredrikNoren/ungit/issues/679)
